import type { FieldValues } from 'react-hook-form';
import type { FormConfig } from '../../types/FormConfig';
export default function useFieldState<TFieldValues extends FieldValues>(name: keyof TFieldValues): {
    /**
     * field is not valid.
     *
        Condition: subscribe to errors.
     */
    invalid: boolean;
    /**
     * field is modified.
     *
     * Condition: subscribe to dirtyFields.
     */
    isDirty: boolean;
    /**
     * 	field has received a focus and blur event.
     *
        Condition: subscribe to touchedFields.
     */
    isTouched: boolean;
    /**
     * field error object.
        Condition: subscribe to errors.
     */
    error: {
        /**
         * Error type.
         */
        type: import("react-hook-form").LiteralUnion<"required" | "min" | "max" | "maxLength" | "minLength" | "validate" | "value" | "setValueAs" | "shouldUnregister" | "onChange" | "onBlur" | "disabled" | "deps" | "pattern" | "valueAsNumber" | "valueAsDate", string> | undefined;
        root: import("react-hook-form").FieldError | undefined;
        /**
         * Element reference
         */
        ref: import("react-hook-form").Ref | undefined;
        types: import("react-hook-form").MultipleFieldErrors | undefined;
        /**
         * Error message
         */
        message: string | undefined;
    };
};
export declare function useContextSelectorFieldState<TFieldValues extends FieldValues, Selected>(name: keyof TFieldValues, callback: (parameters: ReturnType<FormConfig['form']['methods']['getFieldState']>) => Selected): Selected;
//# sourceMappingURL=useFieldState.d.ts.map